/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2015 - 2022 Axel Wickenkamp, Balthasar Weitzel, Dominik Schnier
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.datamanagement.communication.repos;

import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import de.fhg.iese.dd.platform.datamanagement.communication.model.Chat;
import de.fhg.iese.dd.platform.datamanagement.communication.model.ChatMessage;
import de.fhg.iese.dd.platform.datamanagement.communication.repos.results.ChatMessageCountByGeoAreaId;
import de.fhg.iese.dd.platform.datamanagement.participants.person.model.Person;

@Transactional(readOnly = true)
public interface ChatMessageRepository extends JpaRepository<ChatMessage, String> {

    Page<ChatMessage> findAllByChatAndCreatedGreaterThan(Chat chat, long fromTimestamp, Pageable pageable);

    List<ChatMessage> findAllByChatOrderByCreatedDesc(Chat chat);

    ChatMessage findFirstByChatOrderByCreatedDesc(Chat chat);

    ChatMessage findFirstByChatAndAutoGeneratedFalseOrderByCreatedDesc(Chat chat);

    @Transactional(readOnly = false)
    void deleteByChatId(String chatId);

    long countAllByChat(Chat chat);

    @Query("select count(distinct chatMessage) " +
            "from ChatMessage chatMessage " +
            "where chatMessage.chat = :chat " +
            "and chatMessage.created > :created " +
            "and (chatMessage.sender <> :person or chatMessage.sender is null)")
    long countChatMessagesNewerThanTimestampAndNotSentByPerson(Chat chat, long created, Person person);

    @Query("select count(distinct chatMessage) " +
            "from ChatMessage chatMessage " +
            "where chatMessage.chat = :chat " +
            "and (chatMessage.sender <> :person or chatMessage.sender is null)")
    long countChatMessagesNotSentByPerson(Chat chat, Person person);

    @Query("select new de.fhg.iese.dd.platform.datamanagement.communication.repos.results.ChatMessageCountByGeoAreaId(" +
            "cm.sender.homeArea.id, " +
            "count(cm)) " +
            "from ChatMessage cm " +
            "where cm.created >= :lastCreated " +
            "group by cm.sender.homeArea ")
    List<ChatMessageCountByGeoAreaId> countByGeoAreaId(long lastCreated);

}
